
def is_matrix(L):
  # (1) check that L is a list
  if not (type(L) is list):
    return False
  
  # so L is a list, now we have to check for each element of L:
  # (2) whether it is a list;
  # (3) and if they all have the same size.

  # check that the first row is a list
  if not (type(L[0]) is list):
    return False

  # the first row is a list, so we can save its length
  # as the length that all of them should be
  first_row_len = len(L[0])
  
  # (notice we use a slice: L[1:] to take all but the first row)
  for row in L[1:]:
    if not (type(row) is list) or len(row) != first_row_len:
      # either the row is not a list, or it's not the right length
      return False
  
  # if we've made it this far, then L is indeed a matrix
  return True
